Maintain your Redox repository for TEFCA-CommonWell

Last updated: Jun 10, 2026
DEVELOPER
HEALTH TECH VENDOR
Who can use this how-to
  • Existing customers using Network Onramps

All TEFCA-CommonWell participants must respond to requests they receive from other network participants. In some cases, you may receive a high volume of requests per day.

With Redox as your responder, we respond to incoming patient requests on your behalf. However, you must push patient records and documents to your Redox data on demand repository so that we have an accurate representation of each of your patients.

Prerequisites

  • You must have created a TEFCA-CommonWell organization record and populated your Redox data on demand repository with your existing patients. Patient demographic data must be up-to-date in your repository.
  • (Optional) Test sending these requests with our TEFCA-CommonWell sandbox.
    Use curl for technical validation

    You can copy our code examples and send the test requests with curl (learn more about curl) instead of Postman. If you do, remember to:

    • Remove any comments from the code examples (starting with //).
    • Replace any variables (e.g., {{YOUR-VARIABLE}}).
    • Add the source-id if you have multiple sources. We don’t include {{source-id}} in the code examples, so you’ll have to add them yourself. Learn about including source details.
    • Make sure you have a full request for your own use since some of the code examples are abbreviated.

    Check out these troubleshooting guides if you run into errors:

  • Be familiar with the following terms and concepts to send your queries to TEFCA-CommonWell:

By default, we treat each patient as consented if their data is saved into your Redox data on demand repository. This means we can return the patients data if requested by another network participant.

Patient declines to share data

If a patient declines consent, however, you can send a PatientAdmin.PatientUpdate with the Consent extension (learn about extensions). You can toggle the patient’s consent status to declined by sending an empty codeableConcept with the Consent extension. When a patient’s consent status changes, any of their existing data will no longer be returned to network participants.

Example: Declined patient consent in Consent extension
json
1
curl \
2
-X POST https://api.redoxengine.com/endpoint \
3
-H "Content-Type: application/json" \
4
-H "Authorization: Bearer $API_TOKEN" \
5
-d '{
6
"Meta": {
7
"Extensions": {
8
"sender-organization-id": {
9
"url": "https://api.redoxengine.com/extensions/sender-organization-id",
10
"string": "{{ORGANIZATION-OID}}"
11
},
12
"user-id": {
13
"url": "https://api.redoxengine.com/extensions/user-id",
14
"string": "{{SENDING-USER-NAME}}"
15
},
16
"user-role": {
17
"url": "https://api.redoxengine.com/extensions/user-role",
18
"coding": {
19
"code": "112247003",
20
"display": "Medical Doctor"
21
}
22
},
23
"purpose-of-use": {
24
"url": "https://api.redoxengine.com/extensions/purpose-of-use",
25
"coding": {
26
"code": "TREATMENT",
27
"display": "Treatment"
28
}
29
}
30
},
31
"DataModel": "PatientAdmin",
32
"EventType": "PatientUpdate",
33
"Test": true,
34
"Destinations": [
35
{
36
"ID": "{{DATA-ON-DEMAND-REPOSITORY-ID}}"
37
}
38
]
39
},
40
"Patient": {
41
"Identifiers": [
42
{
43
"ID": "1234",
44
"IDType": "MR"
45
}
46
],
47
"Demographics": {
48
{
49
...
50
}
51
},
52
"Notes": [],
53
"Contacts": [
54
{
55
...
56
}
57
],
58
"Diagnoses": [
59
{
60
...
61
}
62
],
63
"Allergies": [
64
{
65
...
66
}
67
],
68
"PCP": {
69
{
70
...
71
}
72
},
73
"Insurances": [
74
{
75
...
76
}
77
],
78
"Guarantor": {
79
...
80
},
81
"Extensions": {
82
"consent-type": {
83
"url": "https://api.redoxengine.com/extensions/consent-type",
84
"codeableConcept": []
85
},
86
}
87
}
88
}
API reference

Review the PatientAdmin data model schema for full requirements.

Patient consents to share data after declining

If a patient consents to share their data initially, nothing needs to be done. However, if a patient has declined consent previously and chooses to consent later, follow these instructions.

Send a PatientAdmin.PatientUpdate with codeableConcept populated as it is in the example below. This text toggles a patient’s consent status again so their data can be shared with network participants.

Example: Toggle a patient’s consent with the Consent extension
json
1
{
2
"url": "https://api.redoxengine.com/extensions/consent-type",
3
"codeableConcept": [
4
{
5
"text": "Treatment",
6
"coding": [
7
{
8
"system": "2.16.840.1.113883.3.18.7.1",
9
"code": "TREATMENT",
10
"display": "Treatment"
11
}
12
]
13
},
14
{
15
"text": "Request of the Individual",
16
"coding": [
17
{
18
"system": "2.16.840.1.113883.3.18.7.1",
19
"code": "REQUEST",
20
"display": "Request of the Individual"
21
}
22
]
23
},
24
]
25
}

Save patient documents

After providing care for a patient, save the patient summary documents to your data on demand repository so Redox can respond to requests for documents from other network participants. You must include certain data when you're returning data to the network. Check out the rules for returned data.

Send a ClinicalSummary.VisitPush request with all the available unique clinical information that you produce. Be mindful of these requirements and best practices:

Field

Notes

Meta.Test

Set this value to False for production requests.

Meta.Destinations.ID

This value changes based on environment type. For VisitPush, this is the data on demand repository ID that your Technical Account Manager gives to you.

Header.Patient.Identifiers[].IDType

At least one patient identifier should include an ID Type that matches the patient identification OID used in the PatientAdmin messages. Typically, this is MR.

Header.Document.ID

This ID must be globally unique across TEFCA-CommonWell as either a GUID or an internally unique ID prefixed with your organizational OID.

Our examples use the OID prefix.

Header.Document.Type

Header.Document.TypeCode

These values should be a LOINC code. Typically, you should use the code for a Continuity of Care Document (i.e., 34133-9).

When sending a document related to a single patient visit, you should use these codes:

Use Progress Notes (i.e., 11506-3) for outpatient/ambulatory visits.

Use discharge summary (i.e., 18842-5) for inpatient/hospital visits.

Header.Document.Custodian.Name

We recommend populating this value since it tells other clinical network participants where the data came from.

If this field isn’t populated, the value defaults to the Meta.Source.Name, which is set based on the source you’re sending the request from.

We encourage you to populate as much of the Header.Document.Custodian.Name object as possible. Most entries use the same data as their directory, but you may want more or less granularity.

Documents[].Author.Location

Some external systems use this to display the location the document originated from when viewing a list documents. When looking at an individual document, Custodian.Name is typically used instead.

Typically, the Author and Custodian values are the same, but they may differ. If not supplied, Redox sets this to the directory entry name you’ve saved to TEFCA-CommonWell.

See the difference between Author and Custodian.

Since ClinicalSummary.VisitPush is lengthy, we include an abbreviated example below. Check out a full example or view the Postman package.

Example: Save a patient document (abbreviated)
bash
1
curl \
2
-X POST https://api.redoxengine.com/endpoint \
3
-H "Content-Type: application/json" \
4
-H "Authorization: Bearer $API_TOKEN" \
5
-d '{
6
"Meta": {
7
"DataModel": "Clinical Summary",
8
"EventType": "VisitPush",
9
"Test": true,
10
"Destinations": [
11
{
12
"ID": "{{DATA-ON-DEMAND-REPOSITORY-ID}}"
13
}
14
]
15
},
16
"Header": {
17
"DirectAddressFrom": null,
18
"DirectAddressTo": null,
19
"Document": {
20
"Author": {
21
"ID": "4356789876",
22
"IDType": "NPI",
23
"Type": null,
24
"FirstName": "Pat",
25
"LastName": "Granite",
26
"Credentials": [
27
"MD"
28
],
29
"Address": {
30
"StreetAddress": "123 Main St.",
31
"City": "Madison",
32
"State": "WI",
33
"ZIP": "53703",
34
"County": "Dane",
35
"Country": "USA"
36
},
37
"EmailAddresses": [],
38
"PhoneNumber": {
39
"Office": "+16085551234"
40
},
41
"Location": { ...
42
}
43
},
44
"ID": "{{REDOX-PARENT-OID}}^67890",
45
"Locale": "US",
46
"Title": "Community Health and Hospitals: Annual Physical",
47
"DateTime": "2012-09-12T00:00:00.000Z",
48
"Type": "Progress Note",
49
"TypeCode": {
50
"Code": "11506-3",
51
"CodeSystem": "2.16.840.1.113883.6.1",
52
"CodeSystemName": "LOINC",
53
"Name": "Progress Note"
54
},
55
"Visit": {
56
"Location": {
57
"Type": "Outpatient Clinic",
58
"Facility": "RHS Vista Oaks Clinic",
59
"Department": "Vista Oaks Clinic",
60
"Room": null
61
},
62
"StartDateTime": "2020-11-12T00:18:30.592Z",
63
"EndDateTime": "2020-11-12T00:18:30.592Z",
64
"Reason": "Annual Physical",
65
"VisitNumber": "30311442"
66
}
67
},
68
"Patient": {
69
"Identifiers": [
70
{
71
"ID": "1234",
72
"IDType": "MR"
73
}
74
],
75
"FirstName": "Timothy",
76
"MiddleName": "Paul",
77
"LastName": "Bixby",
78
"DOB": "2008-01-06",
79
"SSN": "101-01-0001",
80
"Sex": "Male",
81
"Race": "White",
82
"IsHispanic": null,
83
"MaritalStatus": "Married",
84
"IsDeceased": null,
85
"DeathDateTime": null,
86
"PhoneNumber": {
87
"Home": "+18088675301",
88
},
89
"EmailAddresses": [],
90
"Language": "en",
91
"Citizenship": [],
92
"Address": {
93
"StreetAddress": "4762 Hickory Street",
94
"City": "Monroe",
95
"State": "WI",
96
"ZIP": "53566",
97
"County": "Green",
98
"Country": "US"
99
}
100
},
101
"PCP": { ...
102
}
103
},
104
"AdvanceDirectivesText": "
105
Directive Description Verification Supporting Document(s)
106
Resuscitation status Do not resuscitate Dr. Robert Dolin, Nov 07, 1999 Advance directive
107
",
108
"AdvanceDirectives": [
109
{
110
"Type": {
111
"Code": "304251008",
112
"CodeSystem": "2.16.840.1.113883.6.96",
113
"CodeSystemName": "SNOMED CT",
114
"Name": "Resuscitation",
115
"AltCodes": []
116
},
117
"Code": "304253006",
118
"CodeSystem": "2.16.840.1.113883.6.96",
119
"CodeSystemName": "SNOMED CT",
120
"Name": "Do not resuscitate",
121
"AltCodes": [],
122
"StartDate": "2011-02-13T05:00:00.000Z",
123
"EndDate": null,
124
"ExternalReference": "AdvanceDirective.b50b7910-7ffb-4f4c-bbe4-177ed68cbbf3.pdf",
125
"VerifiedBy": [
126
{
127
"FirstName": "Robert",
128
"LastName": "Dolin",
129
"Credentials": "Dr.",
130
"DateTime": null
131
}
132
],
133
"Custodians": [
134
{
135
"FirstName": "Robert",
136
"LastName": "Dolin",
137
"Credentials": "Dr.",
138
"Address": { ...
139
}
140
}
141
]
142
}
143
],
144
"AllergyText": "
145
Substance Reaction Severity Status
146
Penicillin G benzathine Hives Moderate to severe Inactive
147
Codeine Shortness of Breath Moderate Active
148
Aspirin Hives Mild to moderate Active
149
",
150
"Allergies": [ ...
151
] ...
152
}
153
],
154
"AssessmentText": "Recurrent GI bleed of unknown etiology; hypotension perhaps secondary to this but as likely secondary to polypharmacy.Acute on chronic anemia secondary to #1.Azotemia, acute renal failure with volume loss secondary to #1.Hyperkalemia secondary to #3 and on ACE and K+ supplement.Other chronic diagnoses as noted above, currently stable.Also, this person has back problems.",
155
"Assessment": {
156
"Diagnoses": [
157
{
158
"Value": "Displacement of lumbar intervertebral disc without myelopathy",
159
"DateTime": "2009-11-01T05:00:00.000Z",
160
"IsNegativeIndicator": false,
161
"Codes": [
162
{
163
"Code": "202708005",
164
"CodeSystem": "2.16.840.1.113883.6.96",
165
"CodeSystemName": "SNOMED-CT",
166
"Name": "Herniated lumbar intervertebral disc"
167
},
168
{ ...
169
}
170
]
171
},
172
{
173
"Value": "Thoracic or lumbosacral neuritis or radiculitis, unspecified",
174
"DateTime": "2009-11-01T05:00:00.000Z",
175
"IsNegativeIndicator": false,
176
"Codes": [
177
{
178
"Code": "M54.16",
179
"CodeSystem": "2.16.840.1.113883.6.90",
180
"CodeSystemName": "ICD-10",
181
"Name": "Right lumbar radiculopathy"
182
}
183
]
184
}
185
]
186
},
187
"ChiefComplaintText": "Dark stools.",
188
"EncountersText": "
189
Encounter Performer Location Date
190
Pnuemonia Dr Henry Seven Community Health and Hospitals 20120806
191
",
192
"Encounters": [
193
{
194
"Identifiers": [
195
{
196
"ID": "2376492",
197
"IDType": "URMC Epic CSN"
198
}, ...
199
],
200
"Type": {
201
"Code": "99222",
202
"CodeSystem": "2.16.840.1.113883.6.12",
203
"CodeSystemName": "CPT",
204
"Name": "InPatient Admission",
205
"AltCodes": []
206
},
207
"DateTime": "2012-08-06T04:00:00.000Z",
208
"EndDateTime": null,
209
"Providers": [ ...
210
],
211
"Diagnosis": [
212
{
213
"Code": "233604007",
214
"CodeSystem": "2.16.840.1.113883.6.96",
215
"CodeSystemName": "SNOMED CT",
216
"Name": "Pneumonia",
217
"AltCodes": []
218
}
219
],
220
"ReasonForVisit": [
221
{
222
"Code": "233604007",
223
"CodeSystem": "2.16.840.1.113883.6.96",
224
"CodeSystemName": "SNOMED CT",
225
"Name": "Pneumonia",
226
"AltCodes": []
227
}
228
]
229
}
230
],
231
"FamilyHistoryText": "Father (deceased)
232
Diagnosis Age At Onset
233
Myocardial Infarction (cause of death) 57
234
Diabetes 40
235
",
236
"FamilyHistory": [ ...
237
],
238
"HistoryOfPresentIllnessText": "Kelp, Lonnie Ray Sr., MD PHD - 10/21/2014 8:07 PM PSTDate: 10/21/2014
239
240
Pre-procedure diagnosis: L5 S1 Acute Lumbar Radiculopathy (Right)
241
242
Post-procedure diagnosis: Same
243
244
Procedure: 1) L5S1 Transforaminal Epidural Steroid injection(Right)
245
2) Fluoroscopic Guidance for needle placement
246
247
Complications: None
248
249
CONSENT: Today's procedure, its potential benefits as well as its risks and potential side effects were reviewed. Discussed risks of the procedure include bleeding, infection, nerve irritation or damage, reactions to the medications, headache, failure of the pain to improve, and exacerbation of the pain were explained to the patient, who verbalized understanding and who wished to proceed. Informed consent was signed.
250
251
DESCRIPTION OF PROCEDURES: After written informed consent was obtained, the patient was taken to the fluoroscopy suite. Anatomical landmarks were identified by way of fluoroscopy in multiple views. Strict aseptic technique was utilized.
252
253
A 22-gauge 3-1/2-inch needle was then incrementally advanced using multiple fluoroscopic views from an oblique approach into the Right L5S1 lumbar intervertebral space. Both AP and lateral views were used to confirm final needle placement. After negative aspiration, Omniopaque 240 contrast was injected which delineated epidural without vascular flow and a normal epidurogram under fluoroscopy in the lateral and AP view. After negative aspiration was reconfirmed, a 1.0 mL of 0.25% Bupivicaine and 1mL of 40 mg/mL of Kenalog was slowly injected into the epidural space.
254
255
All needles were removed intact. Hemostasis was maintained. There were no complications. The area was cleaned and a Band-Aid placed as necessary. The patient tolerated the procedure well and all needles were removed intact. After a period of observation, the patient was noted to be hemodynamically stable and neurovascularly intact following the procedure as prior to the procedure, and was ultimately discharged to home with supervision in good condition. The patient was instructed to schedule an appointment in the office within 2 weeks.
256
Lonnie Ray Kelp Sr., MD PHD
257
258
",
259
"ImmunizationText": "
260
Vaccine Date Status
261
Influenza virus vaccine, IM May 2012 Completed
262
Tetanus and diphtheria toxoids, IM Apr 2012 Completed
263
",
264
"Immunizations": [ ...
265
],
266
"InstructionsText": "Please carefully follow the subsequent instructions and patient education:
267
268
FlossBrush teeth twice daily
269
270
Scarf tying instructions may be found online.",
271
"InsurancesText": null,
272
"Insurances": [
273
{
274
"Plan": { ...
275
}
276
}
277
],
278
"InterventionsText": "Patient practiced use of novel prosthesis including movements formerly neglected including distal extension and retroflexive hyperextension.",
279
"MedicalEquipmentText": "
280
Supply/Device Date Supplied
281
Automatic implantable cardioverter/defibrillator Nov 1999
282
Total hip replacement prosthesis 1998
283
Wheelchair 1999
284
",
285
"MedicalEquipment": [ ...
286
],
287
"MedicationsText": "
288
Medication Directions Start Date Status Indications Fill Instructions
289
Albuterol 0.09 MG/ACTUAT inhalant solution 0.09 MG/ACTUAT inhalant solution, 2 puffs once 20120806 Active Pneumonia (233604007 SNOMED CT) Generic Substitition Allowed
290
",
291
"Medications": [ ...
292
],
293
"MedicationsAdministeredText": "
294
Medication Start Date Status
295
Albuterol 0.09 MG/ACTUAT inhalant solution 0.09 MG/ACTUAT inhalant solution, 2 puffs once 20120806 Active
296
",
297
"MedicationsAdministered": [ ...
298
],
299
"ObjectiveText": "Chest: clear to ausc. No rales, normal breath soundsHeart: RR, PMI in normal location and no heave or evidence ofcardiomegaly,normal heart sounds, no murm or gallop",
300
"PhysicalExamText": "All examinations performed within normal limits.
301
302
WNL
303
304
Nothing to report here.",
305
"PlanOfCareText": "
306
Planned Activity Planned Date
307
Consultation with Dr George Potomac for Asthma 20120820
308
Chest X-ray 20120826
309
Sputum Culture 20120820
310
",
311
"PlanOfCare": { ...
312
},
313
"ProblemsText": "Pneumonia : Status - ResolvedAsthma : Status - Active",
314
"Problems": [ ...
315
],
316
"ProceduresText": "
317
Procedure Date
318
Chest X-Ray 8/7/2012
319
",
320
"Procedures": { ...
321
},
322
"ReasonForReferralText": "
323
Incoming Referral Reason Specialty Diagnoses / Procedures Referred By Contact Referred To Contact
324
Consult, Test & Treat (Routine) BA-Physical Medicine / Physical Medicine and Rehab DiagnosesRadiculopathy, lumbar regionL5S1 TTRANSFORMINAL ESIL5S1 TTRANSFORMINAL ESIProceduresPR INJECT ANES/STEROID FORAMEN LUMBAR/SACRAL W IMG GUIDE ,1 LEVELINJECTION Kelp, Lonnie Ray Sr., MD PHD Kelp, Lonnie Ray Sr., MD PHD
325
",
326
"ReasonForVisitText": "Light stools.",
327
"ResultText": "
328
LABORATORY INFORMATION
329
Chemistries and drug levels
330
HGB (M 13-18 g/dl; F 12-16 g/dl) 13.2
331
WBC (4.3-10.8 10+3/ul) 6.7
332
PLT (135-145 meq/l) 123 (L)
333
",
334
"Results": [ ...
335
],
336
"ReviewOfSystemsText": "Patient denies recent history of fever or malaise. Positive for weakness and shortness of breath. One episode of melena. No recent headaches. Positive for osteoarthritis in hips, knees and hands.",
337
"SocialHistoryText": "
338
Social History Element Description Effective Dates
339
smoking Former Smoker (1 pack per day 20050501 to 20110227
340
smoking Current Everyday Smoker 2 packs per day 20110227 - today
341
",
342
"SocialHistory": { ...
343
},
344
"SubjectiveText": " Complaints of rectal bleeding, fatigue and a change in bowel patterns. Has several days of constipation alternating with diarrhea. ",
345
"VitalSignsText": "
346
Date / Time: Nov 1, 2011 August 6, 2012
347
Height 69 inches 69 inches
348
Weight 189 lbs 194 lbs
349
Blood Pressure 132/86 mmHg 145/88 mmHg
350
",
351
"VitalSigns": [ ...
352
]
353
}

FHIR® is a registered trademark of Health Level Seven International (HL7) and is used with the permission of HL7. Use of this trademark does not constitute an endorsement of products/services by HL7®.